#include"misc.h"
#include"makelife.h"
#include"showlife.h"
#include"help.h"
#include"mouse.h"

#include<stdlib.h>

miscellaneous misc;

miscellaneous::miscellaneous()
{
 setpos(0,0,22,16);
 settitle("Miscellaneous");
 lbt.setpos(2,8,4,10);
 ubt.setpos(5,5,7,7);
 rbt.setpos(8,8,10,10);
 dbt.setpos(5,11,7,13);
 carpet.setpos(13,4,20,6);
 glider.setpos(13,8,20,10);
 kill.setpos(13,12,20,14);
 char str[2];
 str[1]=0;
 str[0]=30;
 ubt.settext(str);
 str[0]=31;
 dbt.settext(str);
 str[0]=17;
 lbt.settext(str);
 str[0]=16;
 rbt.settext(str);
 carpet.settext("Carpet");
 glider.settext("Glider");
 kill.settext("Kill");
}

void miscellaneous::showall()
{
 titlebox::show();
 if(lbt.pressed) lbt.press();
 else lbt.release();
 if(rbt.pressed) rbt.press();
 else rbt.release();
 if(ubt.pressed) ubt.press();
 else ubt.release();
 if(dbt.pressed) dbt.press();
 else dbt.release();
 if(carpet.pressed) carpet.press();
 else carpet.release();
 if(glider.pressed) glider.press();
 else glider.release();
 if(kill.pressed) kill.press();
 else kill.release();
}

void miscellaneous::show()
{
 int exitdialog=0;
 showall();
 while(!exitdialog)
 if(kbhit())
 switch(getch())
 {
  case 0:
   if(kbhit())
   switch(getch())
   {
    case 72:
     if(showlf.zoom!=3)ubt.press();
     umove();
    break;
    case 80:
     if(showlf.zoom!=3)dbt.press();
     dmove();
    break;
    case 75:
     if(showlf.zoom!=3)lbt.press();
     lmove();
    break;
    case 77:
     if(showlf.zoom!=3)rbt.press();
     rmove();
    break;
    case 59:
     if(showlf.zoom==3)
     {
      showlf.zoomin();
      showlf.show();
      showall();
     }
     help.misc();
     showlf.show();
     showall();
    break;
    case 63:
     zoomin();
    break;
    case 64:
     zoomout();
    break;
   }
  break;
  case 'C':case 'c':case '':case '':
   gencarp();
  break;
  case 'G':case 'g':case '':case '':
   genglid();
  break;
  case 'K':case 'k':case '':case '':
   if(showlf.zoom!=3)kill.press();
   life.kill();
   showlf.show();
   if(showlf.zoom!=3)showall();
  break;
  case '+':
   zoomin();
  break;
  case '-':
   zoomout();
  break;
  default:
   exitdialog=1;
 }
 else if(showlf.zoom!=3)
 {
  ms.getstat();
  if(ubt.mousepress()) umove();
  else if(dbt.mousepress()) dmove();
  else if(lbt.mousepress()) lmove();
  else if(rbt.mousepress()) rmove();
  else if(carpet.mousepress()) gencarp();
  else if(glider.mousepress()) genglid();
  else if(kill.mousepress())
  {
   life.kill();
   showlf.show();
   showall();
  }
  else if((ms.butt==1||ms.butt==2)&&(ms.x>right||ms.y>bottom)) exitdialog=1;
 }
}

void miscellaneous::umove()
{
 unsigned char* tmp;
 tmp=new unsigned char[life.maxX()];
 if(!tmp)
 {
  help.showmessage("No enough memory for operation");
  return;
 }
 int i,j;
 for(i=0;i<life.maxX();i++)
  tmp[i]=life(i,0);
 for(j=0;j<life.maxY()-1;j++)
  for(i=0;i<life.maxX();i++)
   life(i,j)=life(i,j+1);
 for(i=0;i<life.maxX();i++)
  life(i,life.maxY()-1)=tmp[i];
 delete[] tmp;
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::dmove()
{
 unsigned char* tmp;
 tmp=new unsigned char[life.maxX()];
 if(!tmp)
 {
  help.showmessage("No enough memory for operation");
  return;
 }
 int i,j;
 for(i=0;i<life.maxX();i++)
  tmp[i]=life(i,life.maxY()-1);
 for(j=life.maxY()-1;j>0;j--)
  for(i=0;i<life.maxX();i++)
   life(i,j)=life(i,j-1);
 for(i=0;i<life.maxX();i++)
  life(i,0)=tmp[i];
 delete[] tmp;
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::lmove()
{
 unsigned char* tmp;
 tmp=new unsigned char[life.maxY()];
 if(!tmp)
 {
  help.showmessage("No enough memory for operation");
  return;
 }
 int i,j;
 for(j=0;j<life.maxY();j++)
  tmp[j]=life(0,j);
 for(i=0;i<life.maxX()-1;i++)
  for(j=0;j<life.maxY();j++)
   life(i,j)=life(i+1,j);
 for(j=0;j<life.maxY();j++)
  life(life.maxX()-1,j)=tmp[j];
 delete[] tmp;
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::rmove()
{
 unsigned char* tmp;
 tmp=new unsigned char[life.maxY()];
 if(!tmp)
 {
  help.showmessage("No enough memory for operation");
  return;
 }
 int i,j;
 for(j=0;j<life.maxY();j++)
  tmp[j]=life(life.maxX()-1,j);
 for(i=life.maxX()-1;i>0;i--)
  for(j=0;j<life.maxY();j++)
   life(i,j)=life(i-1,j);
 for(j=0;j<life.maxY();j++)
  life(0,j)=tmp[j];
 delete[] tmp;
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::gencarp()
{
 if(showlf.zoom!=3)carpet.press();
 int i,j;
 life.kill();
 life.generation=1;
 for(i=0;i<life.maxY()/2-10;i++)
  for(j=0;j<=i;j++)
   if(random(2))
   {
    life(life.maxX()/2+j,life.maxY()/2+i)=1;
    life(life.maxX()/2-j,life.maxY()/2+i)=1;
    life(life.maxX()/2+j,life.maxY()/2-i)=1;
    life(life.maxX()/2-j,life.maxY()/2-i)=1;
    life(life.maxX()/2+i,life.maxY()/2+j)=1;
    life(life.maxX()/2-i,life.maxY()/2+j)=1;
    life(life.maxX()/2+i,life.maxY()/2-j)=1;
    life(life.maxX()/2-i,life.maxY()/2-j)=1;
   }
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::genglid()
{
 if(showlf.zoom!=3)glider.press();
 int x,y;
 y=random(life.maxY()-20)+10;
 x=random(life.maxX()-20)+10;
 life(x,y)=1;
 switch(random(4))
 {
  default:
   life(x+1,y)=1;
   life(x+2,y)=1;
   life(x,y-1)=1;
   life(x+1,y-2)=1;
  break;
  case 1:
   life(x+1,y)=1;
   life(x+2,y)=1;
   life(x,y+1)=1;
   life(x+1,y+2)=1;
  break;
  case 2:
   life(x-1,y)=1;
   life(x-2,y)=1;
   life(x,y-1)=1;
   life(x-1,y-2)=1;
  break;
  case 3:
   life(x-1,y)=1;
   life(x-2,y)=1;
   life(x,y+1)=1;
   life(x-1,y+2)=1;
  break;
 }
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::zoomin()
{
 showlf.zoomin();
 showlf.show();
 if(showlf.zoom!=3)showall();
}

void miscellaneous::zoomout()
{
 showlf.zoomout();
 showlf.show();
 if(showlf.zoom!=3)showall();
}