#include"life.h"

extern screen scr;
extern help hlp;
extern mouse ms;

void mwindow::setpos(int X0,int Y0,int X1,int Y1)
{
 x0=X0;
 x1=X1;
 y0=Y0;
 y1=Y1;
}

void mwindow::paint()
{
 ms.off();
 scr.pix(x0,y0,2010);
 scr.pix(x0,y1,1984);
 scr.pix(x1,y0,1983);
 scr.pix(x1,y1,2009);
 int i,j;
 for(i=x0+1;i<x1;i++)
 {
  scr.pix(i,y0,1988);
  scr.pix(i,y1,1988);
 }
 for(i=y0+1;i<y1;i++)
 {
  scr.pix(x0,i,1971);
  scr.pix(x1,i,1971);
 }
 for(i=y0+1;i<y1;i++)
  for(j=x0+1;j<x1;j++)
   scr.pix(j,i,1824);
 ms.on();
}

void mwindow::textxy(int x,int y,const char* str,int col)
{
 int i,len=strlen(str);
 ms.off();
 for(i=0;i<len;i++)
 {
  scr.pix(x+i,y,(col<<8)+str[i]);
 }
 ms.on();
}

button::button()
{
 setpos(0,0);
 set("");
}

void button::setpos(int X,int Y)
{
 x=X;
 y=Y;
}

void button::set(char *S)
{
 strcpy(text,S);
}

void button::press()
{
 hlp.textxy(x,y,text);
 ms.off();
 int i;
 int len=strlen(text);
 scr.pix(x-1,y,1971);
 scr.pix(x+len,y,1971);
 scr.pix(x-1,y-1,2010);
 scr.pix(x+len,y-1,1983);
 scr.pix(x-1,y+1,1984);
 scr.pix(x+len,y+1,2009);
 for(i=x;i<x+len;i++)
 {
  scr.pix(i,y-1,1988);
  scr.pix(i,y+1,1988);
 }
 ms.on();
}

void button::release()
{
 ms.off();
 int i;
 int len=strlen(text);
 hlp.textxy(x,y,text,112);
 scr.pix(x-1,y,2011);
 scr.pix(x+len,y,2011);
 for(i=x-1;i<=x+len;i++)
 {
  scr.pix(i,y+1,2011);
  scr.pix(i,y-1,2011);
 }
 ms.on();
}