#include"fildsize.h"
#include"makelife.h"
#include"mouse.h"
#include"clip.h"
#include"showlife.h"
#include"help.h"

fieldsize fldsize;

fieldsize::fieldsize()
{
 setpos(59,0,79,14);
 settitle("Field Size");
 btns[0].setpos(63,4);
 btns[1].setpos(63,6);
 btns[2].setpos(63,8);
 btns[0].settext("80x50");
 btns[1].settext("160x100");
 btns[2].settext("240x150");
 ok.settext("OK");
 cancel.settext("Cancel");
 ok.setpos(61,10,68,12);
 cancel.setpos(70,10,77,12);
}

void fieldsize::showbt()
{
 int i;
 for(i=0;i<3;i++)
 {
  if(i==select)
   btns[i].checked=1;
  else
   btns[i].checked=0;
  btns[i].show();
 }
}

void fieldsize::showall()
{
 ms.off();
 titlebox::show();
 showbt();
 ok.release();
 cancel.release();
 ms.on();
}

void fieldsize::show()
{
 select=life.zoom-1;
 showall();
 exitstatus=0;
 while(!exitstatus)
 {
  if(kbhit())
  switch(getch())
  {
   case 0:
    if(kbhit())
    switch(getch())
    {
     case 59:
      help.field();
      showlf.show();
      showall();
     break;
     case 72:
      if(select>0)select--;
      ms.off();
      showbt();
      ms.on();
     break;
     case 80:
      if(select<2)select++;
      ms.off();
      showbt();
      ms.on();
     break;
    }
   break;
   case 13:case ' ':
    ms.off();
    ok.press();
    ms.on();
    exitstatus=2;
   break;
   case 27:
    ms.off();
    cancel.press();
    ms.on();
    exitstatus=1;
   break;
   case 9:
    select++;
    if(select>=3)select=0;
    ms.off();
    showbt();
    ms.on();
   break;
  }
  else
  {
   ms.getstat();
   if(btns[0].click())
   {
    select=0;
    ms.off();
    showbt();
    ms.on();
   }
   else if(btns[1].click())
   {
    select=1;
    ms.off();
    showbt();
    ms.on();
   }
   else if(btns[2].click())
   {
    select=2;
    ms.off();
    showbt();
    ms.on();
   }
   else if(ok.mousepress())
   {
    exitstatus=2;
   }
   else if(cancel.mousepress())
   {
    exitstatus=1;
   }
  }
 }
 if(exitstatus==2&&life.zoom!=(select+1))
 {
  int zoom=life.zoom<(select+1)?life.zoom:(select+1);
  clip.point1(0,0);
  clip.point2(zoom*80-1,zoom*50-1);
  clip.copy();
  while(!life.resize(select+1)&&select>0)
  {
   select--;
  }
  clip.paste(0,0);
  if(showlf.zoom>life.zoom)showlf.zoom=life.zoom;
  showlf.limits();
  showlf.setmax();
 }
}