#include"life.h"

extern life lf;
extern mouse ms;
extern int editing,paused;

help::help()
{
 setpos(18,2,62,46);
}

void help::open(int idx)
{
 ms.on();
 switch(idx)
 {
  case 0:
   if(editing)edithelp();
   else if(paused) pausehelp();
   else viewhelp();
  break;
  case 31:
   savehelp();
  break;
  case 24:
   openhelp();
  break;
  case 1:
   mischelp();
  break;
 }
 while(1)
 {
  if(kbhit())
  {
   if(getch()==0)getch();
   break;
  }
  if(ms.butt())break;
 }
 lf.chX=lf.chY=1;
 lf.print();
}

void help::edithelp()
{
 setpos(20,5,59,40);
 paint();
 int y;
 textxy(x0+12,y=y0+2,"\x13 It's My LIFE \x13");
 textxy(x0+10,++y,"version 1.0 (30.5.0)");
 textxy(x0+7,y+=2,"Now you are in a Edit mode");
 textxy(x0+3,y+=2,"H,F1 - this Help window");
 textxy(x0+3,++y,"S,F2 - Save now!");
 textxy(x0+3,++y,"A,Alt+F2 - sAve As");
 textxy(x0+3,++y,"O,F3 - Open file");
 textxy(x0+3,++y,"Q,F5 - Quadrant/full mode");
 textxy(x0+3,++y,"E,F6 - go to paused View mode");
 textxy(x0+3,++y,"L,F9 - go to full unpaused View");
 textxy(x0+3,++y,"Esc,F10 - Escape");
 textxy(x0+3,++y,"M,F12 - Miscellaneous");
 textxy(x0+3,++y,"\x1b\x1a\x18\x19 - moving cursor");
 textxy(x0+3,++y,"Ctrl+\x1b\x1a\x18\x19 - moving quadrant");
 textxy(x0+3,++y,"Alt+\x1b\x1a\x18\x19 - painting");
 textxy(x0+3,++y,"Shift+\x1b\x1a\x18\x19 - select region");
 textxy(x0+3,++y,"Ctrl+A - Select All");
 textxy(x0+3,++y,"Space,NumPad5 - create/kill life");
 textxy(x0+3,y+=2,"Mouse left button - create life");
 textxy(x0+3,++y,"Mouse right button - kill life");
 textxy(x0+3,++y,"Shift+mouse moving - select region");
 textxy(x0+3,y+=2,"Clipboard operations:");
 textxy(x0+3,++y,"Ctrl+X,Shift+Del - Cut");
 textxy(x0+3,++y,"Ctrl+C,Ctrl+Ins - Copy");
 textxy(x0+3,++y,"Ctrl+V,Shift+Ins - Paste");
 textxy(x0+3,++y,"Del,Ctrl+Del - Delete selection");
 textxy(x0+3,++y,"Ctrl+Z,Alt+BkSpace - Undo last op");
}

void help::viewhelp()
{
 setpos(20,10,60,38);
 paint();
 int y;
 textxy(x0+12,y=y0+2,"\x13 It's My LIFE \x13");
 textxy(x0+10,++y,"version 1.0 (30.5.0)");
 textxy(x0+7,y+=2,"Now you are in a View mode");
 textxy(x0+5,++y,"and you can press this buttons:");
 textxy(x0+3,y+=2,"H,F1 - Help, this lovely Help");
 textxy(x0+3,++y,"S,F2 - Save now!");
 textxy(x0+3,++y,"A,Alt+F2 - sAve As");
 textxy(x0+3,++y,"O,F3 - Open file");
 textxy(x0+3,++y,"E,F4 - go to Edit mode");
 textxy(x0+3,++y,"Q,F5 - Quadrant/full mode");
 textxy(x0+3,++y,"Esc,F10 - Escape");
 textxy(x0+3,++y,"P,F8 - Pause");
 textxy(x0+3,++y,"M,F12 - Miscellaneous");
 textxy(x0+3,++y,"\x1b\x1a\x18\x19 - moving in quadrant mode");
 textxy(x0+3,y+=2,"Mouse left button - zoom in, moving");
 textxy(x0+3,++y,"Mouse right button - zoom out");
 textxy(x0+3,y+=4,"Thanks to Pop & Goodw!n & TECH Help");
 textxy(x0+12,++y,"(c) Gelin 2000");
}

void help::pausehelp()
{
 setpos(20,10,60,36);
 paint();
 int y;
 textxy(x0+12,y=y0+2,"\x13 It's My LIFE \x13");
 textxy(x0+10,++y,"version 1.0 (30.5.0)");
 textxy(x0+10,y+=2,"Now you are Paused");
 textxy(x0+10,++y,"and you can press:");
 textxy(x0+3,y+=2,"Space - Step by Step");
 textxy(x0+3,++y,"H,F1 - Help, this Help");
 textxy(x0+3,++y,"S,F2 - Save now!");
 textxy(x0+3,++y,"A,Alt+F2 - sAve As");
 textxy(x0+3,++y,"O,F3 - Open file");
 textxy(x0+3,++y,"E,F4 - go to Edit mode");
 textxy(x0+3,++y,"Q,F5 - Quadrant/full mode");
 textxy(x0+3,++y,"L,F9 - Let's Life Live !");
 textxy(x0+3,++y,"Esc,F10 - Escape");
 textxy(x0+3,++y,"M,F12 - Miscellaneous");
 textxy(x0+3,++y,"Any key - go to View mode");
 textxy(x0+3,++y,"\x1b\x1a\x18\x19 - moving in quadrant mode");
 textxy(x0+3,y+=2,"Mouse left button - zoom in, moving");
 textxy(x0+3,++y,"Mouse right button - zoom out");
}

void help::openhelp()
{
 setpos(42,35,79,49);
 paint();
 int y;
 textxy(x0+3,y=y0+2,"This is open file dialog box");
 textxy(x0+3,y+=2,"F1 - show this help");
 textxy(x0+3,++y,"\x18\x19,PgUp,PgDn - select file");
 textxy(x0+3,++y,"Space - change dir, get filename");
 textxy(x0+3,++y,"Enter - change dir, open file");
 textxy(x0+3,++y,"Ctrl+\x18\x19 - select drive");
 textxy(x0+3,++y,"Alt+O - Open file");
 textxy(x0+3,++y,"Any,\x1b\x1a,Del,BkSpace - enter name");
 textxy(x0+3,y+=2,"You can use mouse too");
}

void help::savehelp()
{
 setpos(42,35,79,49);
 paint();
 int y;
 textxy(x0+3,y=y0+2,"This is save file dialog box");
 textxy(x0+3,y+=2,"F1 - show this help");
 textxy(x0+3,++y,"\x18\x19,PgUp,PgDn - select file");
 textxy(x0+3,++y,"Space - change dir, get filename");
 textxy(x0+3,++y,"Enter - change dir, save file");
 textxy(x0+3,++y,"Ctrl+\x18\x19 - select drive");
 textxy(x0+3,++y,"Alt+S - Save file");
 textxy(x0+3,++y,"Any,\x1b\x1a,Del,BkSpace - enter name");
 textxy(x0+3,y+=2,"You can use mouse too");
}

void help::mischelp()
{
 setpos(4,18,35,33);
 paint();
 int y;
 textxy(x0+3,y=y0+2,"This is Miscellaneous");
 textxy(x0+3,y+=2,"F1 - this Help");
 textxy(x0+3,++y,"\x1b\x1a\x18\x19 - Shift all field");
 textxy(x0+3,++y,"C - make magic Carpet");
 textxy(x0+3,++y,"G - Generate random Glider");
 textxy(x0+3,++y,"K - Kill everybody");
 textxy(x0+3,y+=2,"You can click this buttons");
 textxy(x0+3,y+=2,"gps means generations");
 textxy(x0+18,++y,"per second");
}