#include"life.h"

extern life lf;
extern mouse ms;
extern help hlp;

miscellaneous::miscellaneous()
{
 setpos(0,0,22,17);
 sl.setpos(x0+3,y0+10);
 sl.set("\x11");
 sr.setpos(x0+9,y0+10);
 sr.set("\x10");
 su.setpos(x0+6,y0+7);
 su.set("\x1e");
 sd.setpos(x0+6,y0+13);
 sd.set("\x1f");
 car.setpos(x0+14,y0+6);
 car.set("Carpet");
 pl.setpos(x0+14,y0+10);
 pl.set("Glider");
 kil.setpos(x0+14,y0+14);
 kil.set("Kill");
 quit=0;
 mslock=0;
 butpressed=0;
 lasttime=clock();
 lastgen=1;
}

void miscellaneous::open()
{
 quit=0;
 mslock=0;
 butpressed=0;
 ms.on();
 int b,x,y;
 unsigned long t;
 if(t=(clock()-lasttime)) time=(float)(lf.generation-lastgen)/t*CLK_TCK;
 show();
 do
 {
  if(b=ms.butt())
  {
   x=ms.x();
   y=ms.y();
   if((b==1&&!mslock)||b>1)
   {
    if(x>=2&&x<=4&&y>=9&&y<=11)
    {
     shiftleft();
     butpressed=1;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=8&&x<=10&&y>=9&&y<=11)
    {
     shiftright();
     butpressed=2;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=5&&x<=7&&y>=6&&y<=8)
    {
     shiftup();
     butpressed=3;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=5&&x<=7&&y>=12&&y<=14)
    {
     shiftdown();
     butpressed=4;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=13&&x<=20&&y>=5&&y<=7)
    {
     carpet();
     butpressed=5;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=13&&x<=20&&y>=9&&y<=11)
    {
     plane();
     butpressed=6;
     ms.off();
     show();
     ms.on();
    }
    else if(x>=13&&x<=18&&y>=13&&y<=15)
    {
     kil.press();
     lf.kill();
     lf.generation=1;
     butpressed=7;
     ms.off();
     show();
     ms.on();
    }
    else if(x>x1||x<x0||y<y0||y>y1)
    {
     quit=1;
    }
   }
   mslock=1;
  }
  else
  {
   if(butpressed){butpressed=0;ms.off();show();ms.on();}
   mslock=0;
   //butpressed=0;
  }
  if(kbhit())
  {
   switch(getch())
   {
    case 0:
    if(kbhit())switch(getch())
    {
     case 72:
      shiftup();
     break;
     case 80:
      shiftdown();
     break;
     case 75:
      shiftleft();
     break;
     case 77:
      shiftright();
     break;
     case 59:
      hlp.open(1);
     break;
     case 46:
      carpet();
     break;
     case 37:
      kil.press();
      lf.kill();
      lf.generation=1;
     break;
     case 34:
      plane();
     break;
     default:
     quit=1;
    }
    break;
    case 'K':case 'k':case '': case '':
     kil.press();
     lf.kill();
     lf.generation=1;
    break;
    case 'C':case 'c':case '': case '':
     carpet();
    break;
    case 'G':case 'g':case '': case '':
     plane();
    break;
    case 'H':case 'h':case '':case '':
     hlp.open(1);
    break;
    default:
    quit=1;
   }
   show();
  }
 }
 while(!quit);
 lf.print();
 lasttime=clock();
 lastgen=lf.generation;
}

void miscellaneous::show()
{
 lf.print();
 ms.off();
 char str[16];
 ultoa(lf.generation,str,10);
 if(strlen(str)+15>x1)x1=strlen(str)+15;
 paint();
 textxy(2,2,"Generation: ");
 textxy(14,2,str);
 textxy(2,3,"gps: ");
 gcvt(time,8,str);
 textxy(7,3,str);
 switch(butpressed)
 {
  case 0:        // 譥쪮
  sl.release();
  sr.release();
  su.release();
  sd.release();
  car.release();
  pl.release();
  kil.release();
  break;
  case 1:
  sl.press();
  sr.release();
  su.release();
  sd.release();
  car.release();
  pl.release();
  kil.release();
  break;
  case 2:
  sl.release();
  sr.press();
  su.release();
  sd.release();
  car.release();
  pl.release();
  kil.release();
  break;
  case 3:
  sl.release();
  sr.release();
  su.press();
  sd.release();
  car.release();
  pl.release();
  kil.release();
  break;
  case 4:
  sl.release();
  sr.release();
  su.release();
  sd.press();
  car.release();
  pl.release();
  kil.release();
  break;
  case 5:
  sl.release();
  sr.release();
  su.release();
  sd.release();
  car.press();
  pl.release();
  kil.release();
  break;
  case 6:
  sl.release();
  sr.release();
  su.release();
  sd.release();
  car.release();
  pl.press();
  kil.release();
  break;
  case 7:
  sl.release();
  sr.release();
  su.release();
  sd.release();
  car.release();
  pl.release();
  kil.press();
  break;
 }
 ms.on();
}

void miscellaneous::shiftleft()
{
 sl.press();
 unsigned char tmp[100];
 int i,j;
 for(j=0;j<100;j++)
  tmp[j]=lf.areal[j][0];
 for(i=0;i<159;i++)
  for(j=0;j<100;j++)
   lf.areal[j][i]=lf.areal[j][i+1];
 for(j=0;j<100;j++)
  lf.areal[j][159]=tmp[j];
}

void miscellaneous::shiftright()
{
 sr.press();
 unsigned char tmp[100];
 int i,j;
 for(j=0;j<100;j++)
  tmp[j]=lf.areal[j][159];
 for(i=159;i>0;i--)
  for(j=0;j<100;j++)
   lf.areal[j][i]=lf.areal[j][i-1];
 for(j=0;j<100;j++)
  lf.areal[j][0]=tmp[j];
}

void miscellaneous::shiftup()
{
 su.press();
 unsigned char tmp[160];
 int i,j;
 for(i=0;i<160;i++)
  tmp[i]=lf.areal[0][i];
 for(j=0;j<99;j++)
  for(i=0;i<160;i++)
   lf.areal[j][i]=lf.areal[j+1][i];
 for(i=0;i<160;i++)
  lf.areal[99][i]=tmp[i];
}

void miscellaneous::shiftdown()
{
 sd.press();
 unsigned char tmp[160];
 int i,j;
 for(i=0;i<160;i++)
  tmp[i]=lf.areal[99][i];
 for(j=99;j>0;j--)
  for(i=0;i<160;i++)
   lf.areal[j][i]=lf.areal[j-1][i];
 for(i=0;i<160;i++)
  lf.areal[0][i]=tmp[i];
}

void miscellaneous::carpet()
{
 car.press();
 int i,j;
 lf.kill();
 lf.generation=1;
 for(i=0;i<40;i++)
  for(j=0;j<=i;j++)
   if(random(2))
   {
    lf.areal[50+i][80+j]=1;
    lf.areal[50+i][80-j]=1;
    lf.areal[50-i][80+j]=1;
    lf.areal[50-i][80-j]=1;
    lf.areal[50+j][80+i]=1;
    lf.areal[50+j][80-i]=1;
    lf.areal[50-j][80+i]=1;
    lf.areal[50-j][80-i]=1;
   }
}

void miscellaneous::plane()
{
 pl.press();
 int x,y;
 y=random(80)+10;
 x=random(150)+10;
 lf.areal[y][x]=1;
 switch(random(4))
 {
  default:
   lf.areal[y][x+1]=1;
   lf.areal[y][x+2]=1;
   lf.areal[y-1][x]=1;
   lf.areal[y-2][x+1]=1;
  break;
  case 1:
   lf.areal[y][x+1]=1;
   lf.areal[y][x+2]=1;
   lf.areal[y+1][x]=1;
   lf.areal[y+2][x+1]=1;
  break;
  case 2:
   lf.areal[y][x-1]=1;
   lf.areal[y][x-2]=1;
   lf.areal[y-1][x]=1;
   lf.areal[y-2][x-1]=1;
  break;
  case 3:
   lf.areal[y][x-1]=1;
   lf.areal[y][x-2]=1;
   lf.areal[y+1][x]=1;
   lf.areal[y+2][x-1]=1;
  break;
 }
}
